(* HCoop Domtool (http://hcoop.sourceforge.net/)
 * Copyright (c) 2006, Adam Chlipala
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *)

(* PostgreSQL user/table management *)

structure Postgres :> POSTGRES = struct

fun adduser user =
    if Slave.shell [Config.Postgres.adduser, user] then
	NONE
    else
	SOME "Error executing CREATE USER script"

fun createdb {user, dbname} =
    if Slave.shell [Config.Postgres.createdb, user, " ", dbname] then
	NONE
    else
	SOME "Error executing CREATE DATABASE script"

val _ = Dbms.register ("postgres", {adduser = adduser,
				    createdb = createdb})

end
